# generated by datamodel-codegen:
#   filename:  entity/applications/configuration/private/external/metaPilotAppPrivateConfig.json
#   timestamp: 2024-10-17T09:28:17+00:00

from __future__ import annotations

from typing import Optional

from pydantic import ConfigDict, Field
from typing_extensions import Annotated

from metadata.ingestion.models.custom_pydantic import BaseModel, CustomSecretStr

from ......type import basic


class MetaPilotLimits(BaseModel):
    descriptions: Annotated[
        Optional[int],
        Field(
            None,
            description='Maximum number of descriptions generated by the MetaPilot',
        ),
    ]
    queries: Annotated[
        Optional[int],
        Field(None, description='Maximum number of queries generated by MetaPilot.'),
    ]
    billingCycleStart: Annotated[
        Optional[basic.Date], Field(None, description='Start of the billing cycle.')
    ]


class MetaPilotAppPrivateConfig(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    waiiInstance: Annotated[
        str, Field(description='WAII API host URL', title='WAII Instance')
    ]
    digitransURL: Annotated[
        str,
        Field(
            description='Digitrans Server public URL. WAII will use this information to interact with the server. E.g., https://sandbox.trydigitrans.io',
            title='Digitrans URL',
        ),
    ]
    token: Annotated[
        CustomSecretStr, Field(description='WAII API Token', title='WAII API Token')
    ]
    limits: Annotated[
        MetaPilotLimits,
        Field(description='Limits for the MetaPilot Application.', title='Limits'),
    ]
